// SVExtControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SVExtControl.h"
#include "SVExtControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// Registered window message for external process control
const UINT wm_SVMessage = RegisterWindowMessage( _T(SV_REGISTERED_MSG_STRING) );


#define ID_TIMER 7

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVExtControlDlg dialog

CSVExtControlDlg::CSVExtControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSVExtControlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSVExtControlDlg)
	m_Toggle = false;
	m_CFreq = 0;
	m_DemodGroup = -1;
	m_DemodFreq0 = 0;
	m_DemodFreq1 = 0;
	m_SpanFreq = 0;
	m_FileCaptureGroup = -1;
	m_DemodOn = FALSE;
	m_RfGainGroup = -1;
	m_IfGainGroup = -1;
	m_Mute = FALSE;
	m_MarkerTxt = _T("");
	m_SquelchLevelTxt = _T("");
	m_SquelchThreshTxt = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_SquelchSetThreshold = 0;
}

void CSVExtControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSVExtControlDlg)
	DDX_Control(pDX, IDC_MUTECHECK, m_MuteCtrl);
	DDX_Control(pDX, IDC_SQUELCH, m_SquelchCtrl);
	DDX_Control(pDX, IDC_STATUSTXT, m_StatusTxtCtrl);
	DDX_Control(pDX, IDC_SPANFREQEDIT, m_SpanFreqCtrl);
	DDX_Control(pDX, IDC_DEMODFREQEDIT1, m_DemodFreq1Ctrl);
	DDX_Control(pDX, IDC_DEMODFREQEDIT0, m_DemodFreq0Ctrl);
	DDX_Control(pDX, IDC_CFREQEDIT, m_CFeqEditCtrl);
	DDX_Text(pDX, IDC_CFREQEDIT, m_CFreq);
	DDV_MinMaxULongLong(pDX, m_CFreq, 0, 25000000000);
	DDX_Radio(pDX, IDC_DEMODAMRADIO, m_DemodGroup);
	DDX_Text(pDX, IDC_DEMODFREQEDIT0, m_DemodFreq0);
	DDV_MinMaxULongLong(pDX, m_DemodFreq0, 0, 25000000000);
	DDX_Text(pDX, IDC_DEMODFREQEDIT1, m_DemodFreq1);
	DDV_MinMaxULongLong(pDX, m_DemodFreq1, 0, 25000000000);
	DDX_Text(pDX, IDC_SPANFREQEDIT, m_SpanFreq);
	DDV_MinMaxInt(pDX, m_SpanFreq, 0, 30000000);
	DDX_Radio(pDX, IDC_FILECAPTURE_OFF, m_FileCaptureGroup);
	DDX_Check(pDX, IDC_DEMODONCHECK, m_DemodOn);
	DDX_Radio(pDX, IDC_RFGAIN0, m_RfGainGroup);
	DDX_Radio(pDX, IDC_IFGAIN24, m_IfGainGroup);
	DDX_Check(pDX, IDC_MUTECHECK, m_Mute);
	DDX_Text(pDX, IDC_MARKER_TXT, m_MarkerTxt);
	DDX_Text(pDX, IDC_SQUELCHLEVELTXT, m_SquelchLevelTxt);
	DDX_Text(pDX, IDC_SQUELCHTHRESHTXT, m_SquelchThreshTxt);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SQUELCHLEVELTXT, m_SquelchLevelCtrl);
}

BEGIN_MESSAGE_MAP(CSVExtControlDlg, CDialog)
	//{{AFX_MSG_MAP(CSVExtControlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_KILLFOCUS(IDC_CFREQEDIT, OnKillfocusCfreqedit)
	ON_BN_CLICKED(IDC_STARTBUTTON, OnStartbutton)
	ON_BN_CLICKED(IDC_STOPBUTTON, OnStopbutton)
	ON_EN_KILLFOCUS(IDC_SPANFREQEDIT, OnKillfocusSpanfreqedit)
	ON_EN_KILLFOCUS(IDC_DEMODFREQEDIT1, OnKillfocusDemodfreqedit1)
	ON_EN_KILLFOCUS(IDC_DEMODFREQEDIT0, OnKillfocusDemodfreqedit0)
	ON_BN_CLICKED(IDC_DEMODONCHECK, OnDemodoncheck)
	ON_BN_CLICKED(IDC_FILECAPTURE_OFF, OnFilecaptureGroup)
	ON_BN_CLICKED(IDC_RFGAIN0, OnRfgain0)
	ON_BN_CLICKED(IDC_IFGAIN6, OnIfgain24)
	ON_BN_CLICKED(IDC_MUTECHECK, OnMutecheck)
	ON_BN_CLICKED(IDC_GETBUTTON1, OnGetbutton1)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_FILECAPTURE_RF, OnFilecaptureGroup)
	ON_BN_CLICKED(IDC_FILECAPTURE_DEMOD, OnFilecaptureGroup)
	ON_BN_CLICKED(IDC_IFGAIN24, OnIfgain24)
	ON_BN_CLICKED(IDC_IFGAIN18, OnIfgain24)
	ON_BN_CLICKED(IDC_IFGAIN13, OnIfgain24)
	ON_BN_CLICKED(IDC_IFGAIN0, OnIfgain24)
	ON_BN_CLICKED(IDC_RFGAINM10, OnRfgain0)
	ON_BN_CLICKED(IDC_RFGAINM20, OnRfgain0)
	ON_BN_CLICKED(IDC_RFGAINM30, OnRfgain0)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SQUELCHSPIN, OnDeltaposSquelchspin)
	//}}AFX_MSG_MAP
    ON_REGISTERED_MESSAGE(wm_SVMessage, OnSVMessage)
	ON_COMMAND_RANGE(IDC_DEMODAMRADIO, IDC_DEMODNFMRADIO, OnDemodRadioButtons)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVExtControlDlg message handlers

BOOL CSVExtControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_MarkerAmp = 0.0;
	m_MarkerFreq = 0;
	m_StatusTxtCtrl.SetWindowText("Offline");
	m_TimerID = SetTimer( ID_TIMER, 500, NULL);	//start up status timer
	if( m_TimerID == 0)
		AfxMessageBox( "Can't Start Info Timer",MB_OK );
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSVExtControlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSVExtControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSVExtControlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



// Handler for registered window message wm_SVMessage
// which is posted to all top-level windows in the system
// when communicating with an external process
// wParam contains the command and lParam the data.
LRESULT CSVExtControlDlg::OnSVMessage(WPARAM Cmd, LPARAM Data)
{
    // If message is posted from this process do nothing
    if ( !(Cmd & SV_TO_EXTERNAL) )
        return 0;
	Cmd &= ~SV_TO_EXTERNAL;	//get rid of msb flag
	switch(Cmd)
	{
		case SVCMD_STATUS:
			switch(Data)
			{
				case SV_STATUS_OFFLINE:
					m_StatusTxtCtrl.SetWindowText("Offline");
					break;
				case SV_STATUS_IDLE:
					m_StatusTxtCtrl.SetWindowText("Idle");
					break;
				case SV_STATUS_PAUSED:
					m_StatusTxtCtrl.SetWindowText("Paused");
					break;
				case SV_STATUS_RUNNING:
					m_StatusTxtCtrl.SetWindowText("Running");
					break;
			}
			break;
		case SVCMD_SQUELCH:
			if(Data)
				m_SquelchCtrl.SetCheck(TRUE);
			else
				m_SquelchCtrl.SetCheck(FALSE);
			break;
		case SVCMD_SQUELCH_LEV:
			m_SquelchLevelTxt.Format("%5.2f",(float)Data/100.0);
			m_SquelchLevelCtrl.SetWindowTextA(m_SquelchLevelTxt);
			break;
		case SVCMD_SQUELCH_THRESH:
			m_SquelchSetThreshold = Data;
			m_SquelchThreshTxt.Format("%5.2f",(float)Data/100.0);
		  	UpdateData(FALSE);
			break;
		case SVCMD_SET_CENTER_FREQ_MSW:
			m_CFreq = (ULONGLONG)Data<<32;
			break;
		case SVCMD_SET_CENTER_FREQ:
			m_CFreq += (ULONG)Data;
		 	UpdateData(FALSE);
TRACE("\n\rCFreq=%I64d",m_CFreq);

			break;
		case SVCMD_SET_SPAN_FREQ:
			if( (LPARAM)m_SpanFreq != Data)
			{
				m_SpanFreq = Data;
			 	UpdateData(FALSE);
			}
			break;
		case SVCMD_DEMOD_0_FREQ_MSW:
			m_DemodFreq0 = (ULONGLONG)Data<<32;
			break;
		case SVCMD_DEMOD_0_FREQ:
			m_DemodFreq0 += (ULONG)Data;
		 	UpdateData(FALSE);
			break;
		case SVCMD_DEMOD_1_FREQ_MSW:
			m_DemodFreq1 = (ULONGLONG)Data<<32;
			break;
		case SVCMD_DEMOD_1_FREQ:
			m_DemodFreq1 |= (ULONG)Data;
		 	UpdateData(FALSE);
			break;
		case SVCMD_DEMOD_MODE:
			if( (Data>=SV_DEMOD_AM) && (Data<=SV_DEMOD_DSB) )
			{
				m_DemodGroup = Data;
		 		UpdateData(FALSE);
			}
			break;
		case SVCMD_SET_RFGAIN:
			m_RfGainGroup = Data;
		 	UpdateData(FALSE);
			break;
		case SVCMD_SET_IFGAIN:
			m_IfGainGroup = Data;
		 	UpdateData(FALSE);
			break;
		case SVCMD_DEMOD_STATE:
			m_DemodOn = Data;
		 	UpdateData(FALSE);
			break;
		case SVCMD_FILE_CAPTURE_MODE:
			m_FileCaptureGroup = Data;
		 	UpdateData(FALSE);
			break;
		case SVCMD_MUTE:
			if(Data)
				m_MuteCtrl.SetCheck(TRUE);
			else
				m_MuteCtrl.SetCheck(FALSE);
		  	UpdateData(TRUE);
			break;
		case SVCMD_MAX_AMP:
			m_MarkerAmp = (float)Data / (float)100.0;
			break;
		case SVCMD_MAX_FREQ:
			m_MarkerFreq = Data;
			m_MarkerTxt.Format("Mag = %6.2f dB    Freq = %d Hz",m_MarkerAmp, m_MarkerFreq);
		  	UpdateData(FALSE);
			break;
	}
    return 0;
}

void CSVExtControlDlg::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == m_TimerID )
	{
		// Send request squelch level message to SV
		::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SQUELCH_LEV, 0);
#if 0
		if(m_CFreq !=0)
		{
			if(m_Toggle)
			{
				m_Toggle = false;
				::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_CENTER_FREQ_MSW, (LPARAM)(m_CFreq>>32));     
				::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_CENTER_FREQ, (LPARAM)(m_CFreq&0x00000000FFFFFFFF) );     
			}
			else
			{
				m_Toggle = true;
				::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_CENTER_FREQ_MSW, (LPARAM)(m_CFreq>>32));     
				::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_CENTER_FREQ, 1 + (LPARAM)(m_CFreq&0x00000000FFFFFFFF) );     
			}
		}
#endif
	}

	CDialog::OnTimer(nIDEvent);
}

void CSVExtControlDlg::OnStartbutton() 
{
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_START, 0);     
	
}

void CSVExtControlDlg::OnStopbutton() 
{
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_STOP, 0);     
	
}

//////////////////////////////////////////////////////////
// Called whenever a demod mode button is pressed
//////////////////////////////////////////////////////////
void CSVExtControlDlg::OnDemodRadioButtons(UINT nID) 
{
    // Send message to SV
	UpdateData(TRUE);
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_DEMOD_MODE, m_DemodGroup);     
}

//////////////////////////////////////////////////////////
// Called whenever a frequency edit box is changed
//////////////////////////////////////////////////////////
void CSVExtControlDlg::OnKillfocusCfreqedit() 
{
 	UpdateData(TRUE);
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_CENTER_FREQ_MSW, (LPARAM)(m_CFreq>>32));     
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_CENTER_FREQ, (LPARAM)(m_CFreq&0x00000000FFFFFFFF) );     
	
}

void CSVExtControlDlg::OnKillfocusSpanfreqedit() 
{
 	UpdateData(TRUE);
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_SPAN_FREQ, m_SpanFreq);     
	
}

void CSVExtControlDlg::OnKillfocusDemodfreqedit1() 
{
 	UpdateData(TRUE);
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_DEMOD_1_FREQ_MSW,  (LPARAM)(m_DemodFreq1>>32));    
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_DEMOD_1_FREQ, (LPARAM)(m_DemodFreq1 & 0x00000000FFFFFFFF));
	
}

void CSVExtControlDlg::OnKillfocusDemodfreqedit0() 
{
 	UpdateData(TRUE);
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_DEMOD_0_FREQ_MSW,  (LPARAM)(m_DemodFreq0>>32));    
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_DEMOD_0_FREQ, (LPARAM)(m_DemodFreq0 & 0x00000000FFFFFFFF));     
	
}

void CSVExtControlDlg::OnDemodoncheck() 
{
 	UpdateData(TRUE);
int State = SV_DEMOD_OFF;
	if(m_DemodOn)
		State = SV_DEMOD_ON;
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_DEMOD_STATE, State);     
	
}

void CSVExtControlDlg::OnFilecaptureGroup() 
{
	UpdateData(TRUE);
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_FILE_CAPTURE_MODE, m_FileCaptureGroup);     
	
}


void CSVExtControlDlg::OnRfgain0() 
{
 	UpdateData(TRUE);
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_RFGAIN, m_RfGainGroup);     
	
}


void CSVExtControlDlg::OnIfgain24() 
{
 	UpdateData(TRUE);
    // Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SET_IFGAIN, m_IfGainGroup);     
}

void CSVExtControlDlg::OnMutecheck() 
{
  	UpdateData(TRUE);
	if(m_Mute)	// Send message to SV
		::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_MUTE, 1);
	else
		::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_MUTE, 0);   

}

void CSVExtControlDlg::OnGetbutton1() 
{
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_REQ_SETTINGS, 0);   
	
}



void CSVExtControlDlg::OnDeltaposSquelchspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	m_SquelchSetThreshold = m_SquelchSetThreshold - 10*(pNMUpDown->iDelta);
	m_SquelchSetThreshold = 10*(m_SquelchSetThreshold/10);
	if(m_SquelchSetThreshold < -16000)
		m_SquelchSetThreshold = -16000;
	if(m_SquelchSetThreshold > 0)
		m_SquelchSetThreshold = 0;
	// Send message to SV
	::PostMessage(HWND_BROADCAST, wm_SVMessage, (WPARAM)SVCMD_SQUELCH_THRESH, m_SquelchSetThreshold);     
	UpdateData(FALSE);
	*pResult = 0;
}
